/*   ____   ___ _____  _  _____ ___ ___  _   _
    |  _ \ / _ \_   _|/ \|_   _|_ _/ _ \| \ | |
    | |_) | | | || | / _ \ | |  | | | | |  \| |
    |  _ <| |_| || |/ ___ \| |  | | |_| | |\  |
    |_| \_\\___/ |_/_/   \_\_| |___\___/|_| \_|
  * based on ROTATION by Nokia (model 7110)
  * Author: Giovan Battista Rolandi
  * License: GNU GPL v3+
  * Date: November 2014
  * Notes: coded during a boring C++ lesson about passing matrixes to functions
  *
  * Istruzioni:
  * Viene mostrata una matrice disordinata di numeri naturali da 1 a n, dove
  * n è RIGHExCOLONNE della matrice. Lo scopo del giuoco è riordinare i valori
  * della matrice da 1 a n, a partire dall'alto a sinistra fino in basso a
  * destra. Comandi:
  *   IJKL per muovere il cursore (costituito da una sottomatrice 2x2);
  *   UO per ruotare in senso antiorario e orario i numeri nel cursore;
  *   Q quit (ma va?)
  * Quando lo schema è ordinato, non succede niente, perché l'ora era finita
  * e non ho avuto voglia di scrivere altro. Si noti che è già tanto che
  * abbia commentato il codice per i posteri.
*/
#include <iostream>
using namespace std;
#include <cstdlib>
#include <curses.h> /* librerie per la gestione interattiva dello schermo.
                       Ho usato giusto un paio di funzioni della libreria,
                       quello che fanno lo si capisce al volo dal nome. */

short RIGHE, COLONNE; /* dimensioni della matrice di cui si compone il gioco */

/* Mostra lo schermo di gioco */
void stampa(short* matrice, short y, short x, short r, short c)
{
  char g[4]; g[3] = 0; /* creazione della stringa da stampare */
  for (int i = 0; i < y; i++)
  {
    for (int j = 0; j < x; j++)
    {
      if (i == r && j == c) g[0] = '*'; /* stampa del cursore */
        else if (i == r + 1 && j == c || i == r + 1 && j == c + 1 || i == r && j == c + 1) g[0] = '*';
          else g[0] = ' ';
      g[1] = (*(matrice + j + i*x) / 10) + 48; /* calcolo dei codici ASCII dei caratteri (numeri) da stampare */
      g[2] = (*(matrice + j + i*x) % 10) + 48;
      mvprintw((i + 1) * 2, (j + 1) * 4, g);
    }
  }
  return;
}

/* Ruota una sottomatrice 2x2 in senso orario o antiorario all'interno della matrice di gioco */
void ruota(short* matrice, short y, short x, short r, short c, char d)
{
  short t = *(matrice + c + r * x);
  if (d == 'a' || d == 'A') /* senso antiorario, else orario -- you don't say? */
  {
    *(matrice + c + r * x) = *(matrice + c + 1 + r * x);
    *(matrice + c + 1 + r * x) = *(matrice + c + 1 + (r + 1)* x);
    *(matrice + c + 1 + (r + 1) * x) = *(matrice + c + (r + 1) * x);
    *(matrice + c + (r + 1) * x) = t;
  }
  else
  {
    *(matrice + c + r * x) = *(matrice + c + (r + 1) * x);
    *(matrice + c + (r + 1) * x) = *(matrice + c + 1 + (r + 1) * x);
    *(matrice + c + 1 + (r + 1) * x) = *(matrice + c + 1 + r * x);
    *(matrice + c + 1 + r * x) = t;
  }
  return;
}

/* ruota casualmente i valore nella matrice ordinata iniziale (prepara il gioco) */
void mischia(short* matrice, short y, short x)
{
  short c, r; char d;

  for (short i = 0; i < 50; i++)
  {
    c = (double)(rand()) / (double)(RAND_MAX) * (COLONNE - 1);
    r = (double)(rand()) / (double)(RAND_MAX) * (RIGHE - 1);
    d = (rand() > RAND_MAX / 2) ? 'o' : 'a';
    ruota(matrice, RIGHE, COLONNE, r, c, d);
  }
  return;
}

int main() /* EVIDENTEMENTE QUESTO E' IL MAIN */
{
  clog << "Matrice RIGHE   = "; cin >> RIGHE;
  clog << "Matrice COLONNE = "; cin >> COLONNE;
  /*preparazione della finestra ncurses di gioco */
  srand(time(NULL));
  initscr();
  timeout(100);
  keypad(stdscr, TRUE);
  noecho();

  short matrice[RIGHE][COLONNE]; /* sì, lo so, si dovrebbe usare l'allocazione dinamica della memoria, ma usate GNU G++ e nessuno si farà del male */
  /* riempimento della matrice con i valori ordinati iniziali e mescolamento */
  for (int i = 0; i < RIGHE; i++) for (int j = 0; j < COLONNE; j++) matrice[i][j] = i * COLONNE + j + 1;
  mischia(&matrice[0][0], RIGHE, COLONNE);

  short r = 0, c = 0; char d = 'o'; /* riga, colonna e direzione attuale */
  char cmd;

  while(true)
  {
    cmd = getch(); /* keyinput da tastiera */

    switch(cmd)
    {
      case 'j': case 'J': case KEY_LEFT: c--; break; /* spostano il cursore, teoricamente dovrebbe andare anche con le freccette ma a me non va */
      case 'l': case 'L': case KEY_RIGHT: c++; break;
      case 'i': case 'I': case KEY_UP: r--; break;
      case 'k': case 'K': case KEY_DOWN: r++; break;
      case 'o': case 'O': case KEY_ENTER: ruota(&matrice[0][0], RIGHE, COLONNE, r, c, 'o'); break; /* ruota la sottomatrice */
      case 'u': case 'U': ruota(&matrice[0][0], RIGHE, COLONNE, r, c, 'a'); break;
      case 'q': case 'Q': endwin(); return 0; break;
      default: break;
    }

    /* controlli per non uscire dalla matrice e andare in buffer overflow */
    if (r < 0) r = 0; if (c < 0) c = 0;
    if (r >= RIGHE - 1) r = RIGHE - 2;
    if (c >= COLONNE - 1) c = COLONNE - 2;

    stampa(&matrice[0][0], RIGHE, COLONNE, r, c);
    refresh();
  }

  return 0;
}
